//StringUtil.cpp
#include <assert.h>
#include <iostream>
#include <stdio.h>
#include <sstream>
#include "StringUtil.h"


bool ToBool( const std::string& str )
{
	if( str.empty() )
		return false;

	std::istringstream stream( str );
	bool bFlag = false;
	stream >> bFlag;
	return bFlag;
}
//-----------------------------------------------------------------------------
std::string ToString( bool bFlag )
{
    if( bFlag )
		return "true";
	else 
		return "false";
}
//-----------------------------------------------------------------------------
int ToInt( const std::string& str )
{
	if( str.empty() )
		return 0;

	std::istringstream stream( str );
	int num = 0;
	stream >> num;
	return num;
}
//-----------------------------------------------------------------------------
std::string ToString( int num )
{
    std::stringstream ss; 
    ss << num; 
    std::string str = ss.str();
	return str;
}
//-----------------------------------------------------------------------------
float ToFloat( const std::string& str )
{
	if( str.empty() )
		return 0;

	std::istringstream stream( str );
	float num = 0;
	stream >> num;
	return num;
}
//-----------------------------------------------------------------------------
std::string ToString( float num )
{
    std::stringstream ss; 
    ss << num; 
    std::string str = ss.str();
	return str;
}
//-----------------------------------------------------------------------------
base::Vector2 ToVector2( const std::string& str )
{
	base::Vector2 vector( 0, 0 );
	if( str.empty() )
		return vector;

	sscanf_s( str.c_str(), "%f,%f", &vector.x, &vector.y );   
	return vector;
}
//-----------------------------------------------------------------------------
std::string	ToString( const base::Vector2& vector )
{
    std::stringstream ss; 
    ss << vector.x << ", " << vector.y; 
	std::string str = ss.str();
	return str;
}
//-----------------------------------------------------------------------------
base::Vector3 ToVector3( const std::string& str )
{
	base::Vector3 vector( 0, 0, 0 );
	if( str.empty() )
		return vector;

	sscanf_s( str.c_str(), "%f,%f,%f", &vector.x, &vector.y, &vector.z );   
	return vector;
}
//-----------------------------------------------------------------------------
std::string ToString( const base::Vector3& vector )
{
    std::stringstream ss; 
    ss << vector.x << ", " << vector.y << ", " << vector.z ; 
	std::string str = ss.str();
	return str;
}
//-----------------------------------------------------------------------------
base::Vector4 ToVector4( const std::string& str )
{
	base::Vector4 vector( 0, 0, 0, 1 );
	if( str.empty() )
		return vector;

	sscanf_s( str.c_str(), "%f,%f,%f,%f", &vector.x, &vector.y, &vector.z, &vector.w );   
	return vector;
}
//-----------------------------------------------------------------------------
std::string	ToString( const base::Vector4& vector )
{
    std::stringstream ss; 
    ss << vector.x << ", " << vector.y << ", " << vector.z << ", " << vector.w; 
	std::string str = ss.str();
	return str;
}
//-----------------------------------------------------------------------------
base::Matrix ToMatrix( const std::string& str )
{
	base::Matrix mat;
	mat.Init();
	if( str.empty() )
		return mat;

	sscanf_s( str.c_str(), "r1(%f,%f,%f,%f),r2(%f,%f,%f,%f),r3(%f,%f,%f,%f),r4(%f,%f,%f,%f)", 
		&mat._11, &mat._12, &mat._13, &mat._14, &mat._21, &mat._22, &mat._23, &mat._24,
		&mat._31, &mat._32, &mat._33, &mat._34, &mat._41, &mat._42, &mat._43, &mat._44 );  
	return mat;
}
//-----------------------------------------------------------------------------
std::string ToString( const base::Matrix& mat )
{
    std::stringstream ss; 
	ss << "r1(" << mat._11 << ", " << mat._12 << ", " << mat._13 << ", " << mat._14
		<< "),r2(" << mat._21 << ", " << mat._22 << ", " << mat._23 << ", " << mat._24
		<< "),r3(" << mat._31 << ", " << mat._32 << ", " << mat._33 << ", " << mat._34
		<< "),r4(" << mat._41 << ", " << mat._42 << ", " << mat._43 << ", " << mat._44 << ")";
	    
	std::string str = ss.str();
	return str;
}
