//TreeNode.h
#ifndef __TREENODE_H
#define __TREENODE_H

#include <list>
#include <string>


typedef std::string DataType;

template <typename T>
class TreeNode
{
public:
	TreeNode();
	virtual	~TreeNode();

	void	AttachChild( TreeNode* pChild );
	void	DetachChild( TreeNode* pChild );
	TreeNode* GetRoot();

	void			SetData( T* pData );
	T*				GetData();
	static void		PrintAll( TreeNode* pNode );

protected:
	typedef std::list <TreeNode*>	ChildList;

	T*				m_pData;
	TreeNode*		m_pParent;
	ChildList		m_child;  
};

#include "TreeNode.inl"

#endif